ghc-7.0.3: The GHC API

SMRep

# Documentation

type StgWord = Word64 Source

type StgHalfWord = Word32 Source

hALF_WORD_SIZE :: ByteOff Source

hALF_WORD_SIZE_IN_BITS :: Int Source

type WordOff = Int Source

type ByteOff = Int Source

data CgRep Source

Constructors

VoidArg |
PtrArg |
NonPtrArg |
LongArg |
FloatArg |
DoubleArg |

Instances

Eq CgRep |
Outputable CgRep |

nonVoidArg :: CgRep -> Bool Source

argMachRep :: CgRep -> CmmType Source

primRepToCgRep :: PrimRep -> CgRep Source

isFollowableArg :: CgRep -> Bool Source

isVoidArg :: CgRep -> Bool Source

isFloatingArg :: CgRep -> Bool Source

is64BitArg :: CgRep -> Bool Source

separateByPtrFollowness :: [(CgRep, a)] -> ([(CgRep, a)], [(CgRep, a)])Source

cgRepSizeW :: CgRep -> ByteOff Source

cgRepSizeB :: CgRep -> ByteOff Source

retAddrSizeW :: WordOff Source

typeCgRep :: Type -> CgRep Source

idCgRep :: Id -> CgRep Source

tyConCgRep :: TyCon -> CgRep Source

data SMRep Source

Constructors

GenericRep Bool !Int !Int ClosureType |
BlackHoleRep |

data ClosureType Source

Constructors

Constr |
ConstrNoCaf |
Fun |
Thunk |
ThunkSelector |

isStaticRep :: SMRep -> Bool Source

fixedHdrSize :: WordOff Source

arrWordsHdrSize :: ByteOff Source

arrPtrsHdrSize :: ByteOff Source

profHdrSize :: WordOff Source

thunkHdrSize :: WordOff Source

smRepClosureType :: SMRep -> Maybe ClosureType Source

smRepClosureTypeInt :: SMRep -> StgHalfWord Source

rET_SMALL :: StgHalfWord Source

rET_BIG :: StgHalfWord Source